System.ServiceModel 4.0.0.0 System.Enum

This enumeration is used with the property of the and the property of the classes.

If a message is vulnerable to a digest attack (for example, if the message is short or the entropy is low), you should use the or option. (Entropy is random data provided by a server, a client, or both, and is used to create a shared key for encrypting and decrypting data.)

## What Is Ordered?

indigo2 offers three different protection levels that determine how messages are secured using SOAP message security. The default is . This setting first signs the message, encrypts the message body, and then encrypts the XML signature. This reduces the likelihood of a successful cryptographic guessing attack against the signature.

However, using the default has performance implications. In effect, there is a tradeoff of performance for increased security. Encrypting the signature can decrease performance between 10 percent and 40 percent. If the data content of the message is of low value, and performance throughput is more significant, use . With this setting, the signature digest is sent in clear text, and thus the message is more vulnerable to guess-and-verify attacks on low entropy.

## Custom Bindings Only

To change the MessageProtectionOrder property requires the creation of a custom security binding. For more information about creating custom bindings, see Creating User-defined Bindings and Binding Elements. For more information about creating a custom binding for a specific authentication mode, see How To: Create a SecurityBindingElement for a Specified Authentication Mode.

Specifies the order of operations that protect a message.

- Field
  4.0.0.0
  System.ServiceModel.Security.MessageProtectionOrder

  Specifies that the SOAP message is encrypted before a digital signature is generated for the SOAP message.

- Field
  4.0.0.0
  System.ServiceModel.Security.MessageProtectionOrder

  Specifies that a digital signature is generated for the SOAP message before any portion of the SOAP message is encrypted, but the digital signature is not encrypted.

- Field
  4.0.0.0
  System.ServiceModel.Security.MessageProtectionOrder

  Specifies that a digital signature is generated for the SOAP message before any portion of the SOAP message is encrypted, and the digital signature is encrypted.